{=======================================================================================================================

  Comming Library.

       ADO.

========================================================================================================================

  :

  16.08.2017 [+] SetFieldPost.
  06.08.2017 [+] SetStateBrowse.
  07.04.2017 [+] GetField:     Field.DataSet.Active.
  09.02.2016 [+] CURRENT_RECORD_KEY = 'Z0'.
  18.10.2015 [*] ActionEdit   ActionUpdate.
  23.03.2015 [+] DataSetStateEnum:   TDataSetState.
  03.03.2015 [+] SAVE_RECORD:    .
  28.02.2015 [*] RequeryParameters:     .
             [*] SetField:    ,        .
  14.02.2015 [-]   BDE.
  17.09.2014 [!]   D7  XE.
  16.09.2014 [!]  Comming D7  XE.
  09.03.2013 [*] .
  24.03.2012 [+]     : FloatToSQL, DateToSQL.
  21.03.2012 [*] RequeryParameters: WideChar.
  10.02.2012 [*] RequeryParameters: UnicodeString.
  09.02.2012 [!]    Delphi XE2.
  23.06.2011 [+] SetStateEdit:   .
  09.04.2009 [+] ClearDateSetField:    Dataset.
  23.07.2008 [+] ActionSlaveDelete:   TAction  , .
             [+] ActionSlaveEdit:   TAction  , , .
             [+] ActionSlaveInsert:   TAction  , .
  20.07.2008 [+] ActionEdit:   TAction, , , .
             [+] ActionInsert:   TAction, .
  27.12.2006 [*] SetField:   .
  23.06.2005 [*] RequeryParameters:   Currency.
  05.05.2005 [+] SetField:      .
  10.04.2005 [*] DeleteRecord:   -.
  07.04.2005 [+] DeleteRecord:    -.
  17.03.2005 [*] DeleteRecord:       DisplayLabel.
  09.03.2004 [*] RequeryParameters:   Char.
  10.02.2004 [+] GetSectorName:      -.
  19.01.2004 [*]       -.
  10.07.2003 [+] SQLFunction:   .
  27.04.2003 [-] .
  26.04.2003 [*] RequeryParameters:     .
  21.12.2002 [+] SQLExecute:   TADOConnection.
  07.02.2002 [+]  .
  06.02.2002 [*]     TADOCommand;
  08.11.2001 [*] SQLExecute:    - False.
             [+]    TADOQuery.
             [*]      ADO.
  12.09.2001 [*]      Delphi 6  ADO.
  29.05.2001 [+]   CommingBtrieve       
                      TQuery.
             [-]  TAB.
             [*]    CommingBtrieveRx.
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982017 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingADO.pas,v 1.10 2017/08/16 04:00:40 tsk Exp $
=======================================================================================================================}
unit CommingADO;

interface

  uses  Windows, Classes, SysUtils, Forms, Db, Variants, ADODB,
        {$IFDEF VER150} // D7
        DBTables, Registry,
        {$ELSE} // XE
        {BDE.DBTables}Data.SqlExpr, System.Win.Registry,
        {$ENDIF}
        // Comming:
        CommingOther;

  {   }
  function    SQLExecute( Command: TADOCommand; SQLText: String ): Boolean; overload;
  function    SQLExecute( Command: TADOCommand; SQLText: String; const Args: array of const ): Boolean; overload;
  function    SQLExecute( Connect: TADOConnection; SQLText: String ): Boolean; overload;
  function    SQLExecute( Connect: TADOConnection; SQLText: String; const Args: array of const ): Boolean; overload;

  {   }
  function    SQLCalculate( DataSet: TADODataSet; SQLText: String ): Variant; overload;
  function    SQLCalculate( DataSet: TADODataSet; SQLText: String; const Args: array of const ): Variant; overload;
  function    SQLCalculate( Connect: TADOConnection; SQLText: String ): Variant; overload;
  function    SQLCalculate( Connect: TADOConnection; SQLText: String; const Args: array of const ): Variant; overload;

  function    SQLListing( Query: TADOQuery; SQLText: String ): Variant; overload;
  function    SQLListing( Query: TADOQuery; SQLText: String; const Args: array of const ): Variant; overload;

  function    SQLFunction( Connect: TADOConnection; SQLFuntioc: String; const Args: array of const ): Variant;

  {   }
  procedure   DeleteRecord( Table: String; Field: TField; FieldName: String = '*' );

  {  DataSet    }
  procedure   RequeryParameters( DataSet: TADODataSet; const Param: array of const );

  {   TAction }
  function    ActionInsert( DataSet: TADODataSet ): Boolean;
  function    ActionUpdate( DataSet: TADODataSet ): Boolean;
  function    ActionSlaveInsert( Master, Slave: TADODataSet ): Boolean;
  function    ActionSlaveEdit( Master, Slave: TADODataSet ): Boolean;
  function    ActionSlaveDelete( Master, Slave: TADODataSet ): Boolean;

  {     -. }
  procedure   LoadDefaultFromRegistry ( Data: TADODataSet );
  procedure   SaveDefaultToRegistry ( Data: TADODataSet );

  {      . }
  procedure   SetField( Field: TField; Value: Variant );
  procedure   SetFieldPost( Field: TField; Value: Variant );
  function    GetField( Field: TField ): Variant;

  {    Dataset. }
  procedure   ClearDateSetField( Data: TADODataSet );

  {     . }
  procedure   SetStateEdit( Data: TADODataSet );
  procedure   SetStateBrowse( Data: TADODataSet );

  {TDataSetState}
  function    DataSetStateEnum( Data: TADODataSet): String;

  {      }
  function    FloatToSQL( Value: Extended ): String;
  function    DateToSQL( Value: TDateTime ): String;

  var taInter: TADODataSet;
      tcInter: TADOCommand;

  const INSERT_DATA = -1;
        CURRENT_RECORD = -1;
        CURRENT_RECORD_KEY = 'Z0';
        SAVE_RECORD = -1;
        RECORD_ENABLE = 1;

implementation
//======================================================================================================================
function SQLExecute( Command: TADOCommand; SQLText: String ): Boolean;
begin
  with Command do begin
    CommandText := SQLText;
    Execute;
  end;
  Result := True;
end;
//======================================================================================================================
function SQLExecute( Command: TADOCommand; SQLText: String; const Args: array of const ): Boolean;
begin
  Result := SQLExecute( Command, Format( SQLText, Args ));
end;
//======================================================================================================================
function SQLExecute( Connect: TADOConnection; SQLText: String ): Boolean;
begin
  if tcInter = nil then begin
    tcInter := TADOCommand.Create( Application );
    tcInter.Connection := Connect;
  end;
  Result := SQLExecute( tcInter, SQLText )
end;
//======================================================================================================================
function SQLExecute( Connect: TADOConnection; SQLText: String; const Args: array of const ): Boolean;
begin
  Result := SQLExecute( Connect, Format( SQLText, Args ));
end;
//======================================================================================================================
function SQLCalculate( DataSet: TADODataSet; SQLText: String ): Variant; overload;
  var i: Integer;
begin
  with DataSet do begin
    Close;
    CommandText := SQLText;
    Open;
    if RecordCount > 0 then begin
        if Fields.Count > 1 then begin
          Result := VarArrayCreate( [ 0, Fields.Count - 1 ], varVariant );
          for i := 0 to Fields.Count - 1 do begin
            if Fields[i] is TStringField then ( Fields[i] as TStringField ).Transliterate := False;
            Result[i] := Fields[i].AsVariant;
          end;
        end else begin
          Result := Fields[0].AsVariant;
        end
    end else begin
      Result := Null;
    end;
    Close;
  end;
end;
//======================================================================================================================
function SQLCalculate( DataSet: TADODataSet; SQLText: String; const Args: array of const ): Variant; overload;
begin
  Result := SQLCalculate( DataSet, Format( SQLText, Args ));
end;
//======================================================================================================================
function SQLCalculate( Connect: TADOConnection; SQLText: String ): Variant;
begin
  if taInter = nil then begin
    taInter := TADODataSet.Create( nil );
    taInter.Connection := Connect;
  end;
  Result := SQLCalculate( taInter, SQLText )
end;
//======================================================================================================================
function SQLCalculate( Connect: TADOConnection; SQLText: String; const Args: array of const ): Variant; overload;
begin
  Result := SQLCalculate( Connect, Format( SQLText, Args ));
end;
//======================================================================================================================
function SQLFunction( Connect: TADOConnection; SQLFuntioc: String; const Args: array of const ): Variant;
  var SQL: String;
begin
  SQL := 'SELECT dbo.' + SQLFuntioc + '(' + ArrayToList( Args ) + ')';
  Result := SQLCalculate( Connect, SQL );
end;
//======================================================================================================================
function SQLListing( Query: TADOQuery; SQLText: String ): Variant; overload;
  var i: Integer;
begin
  Result := 0;
  with Query do begin
    Close;
    SQL.Text := SQLText;
    try
      Open;
      if RecordCount < 1 then begin
        Result := -1;
        Close;
        Exit;
      end;
      Result := VarArrayCreate([ 1, RecordCount ], varVariant );
      i := 1;
      if Fields[0] is TStringField then ( Fields[0] as TStringField ).Transliterate := False;
      while not eof do begin
        Result[i] := Fields[0].AsVariant;
        Inc( i );
        Next;
      end;
    except on E: Exception do
      if not ( E.Message = 'DBIERR_EOF' ) then raise;
    end;
    Close;
  end;
end;
//======================================================================================================================
function SQLListing( Query: TADOQuery; SQLText: String; const Args: array of const ): Variant; overload;
begin
  Result := SQLListing( Query, Format( SQLText, Args ));
end;
//======================================================================================================================
procedure DeleteRecord( Table: String; Field: TField; FieldName: String );
  var SQL: String;
begin
  if FieldName = '*' then FieldName := Field.FieldName;
  SQL := 'DELETE FROM ' + Table + ' WHERE ' + FieldName + ' = ''' + Field.AsString + '''';
  SQLExecute( TADODataSet(Field.DataSet).Connection, SQL )
end;
//======================================================================================================================
procedure RequeryParameters( DataSet: TADODataSet; const Param: array of const );
  var i, d: Integer;
begin
  d := iif( DataSet.CommandType = cmdStoredProc, 1, 0 );
  DataSet.Close;
  for i := d to DataSet.Parameters.Count - 1 do
    if ( i - d ) <= High( Param ) then
      case Param[i - d].VType of
        vtInteger:      {00}
          DataSet.Parameters[i].Value := Param[i - d].VInteger;
        vtBoolean:      {01}
          DataSet.Parameters[i].Value := Param[i - d].VBoolean;
        vtChar:         {02}
          DataSet.Parameters[i].Value := Param[i - d].VChar;
        vtExtended:     {03}
          DataSet.Parameters[i].Value := Param[i - d].VExtended^;
        vtString:       {04}
          DataSet.Parameters[i].Value := Param[i - d].VString^;
        vtWideChar:     {09}
          DataSet.Parameters[i].Value := Param[i - d].VChar;
        vtAnsiString:   {11}
          DataSet.Parameters[i].Value := String(Param[i - d].VAnsiString);
        vtCurrency:     {12}
          DataSet.Parameters[i].Value := Param[i - d].VCurrency^;
        vtVariant:      {13}
          DataSet.Parameters[i].Value := Param[i - d].VVariant^;
{$IFNDEF VER150} // XE
        vtUnicodeString {17}:
          DataSet.Parameters[i].Value := String(Param[i - d].VAnsiString);
{$ENDIF}
        else
          raise EConvertError.CreateFmt( '   (%d).', [ Param[i - d].VType ]);
      end
    else DataSet.Parameters[i].Value := null;
  DataSet.Open;
end;
//======================================================================================================================
function ActionInsert( DataSet: TADODataSet ): Boolean;
begin
  Result := DataSet.Active;
end;
//======================================================================================================================
function ActionUpdate( DataSet: TADODataSet ): Boolean;
begin
  Result := ( DataSet.Active ) and ( DataSet.RecordCount > 0 );
end;
//======================================================================================================================
function ActionSlaveInsert( Master, Slave: TADODataSet ): Boolean;
begin
  Result := ( Master.Active ) and ( Master.RecordCount > 0 ) and ( Slave.Active );
end;
//======================================================================================================================
function ActionSlaveEdit( Master, Slave: TADODataSet ): Boolean;
begin
  Result := ( Master.Active ) and ( Master.RecordCount > 0 )
              and ( Slave.Active ) and ( Slave.RecordCount > 0);
end;
//======================================================================================================================
function ActionSlaveDelete( Master, Slave: TADODataSet ): Boolean;
begin
  Result := ( Master.Active ) and ( Master.RecordCount > 0 )
              and ( Slave.Active ) and ( Slave.RecordCount = 0);
end;
//======================================================================================================================
function GetSectorName( Data: TADODataSet ): String;
begin
  Result :=  Copy( Data.Owner.ClassName, 2, Length( Data.Owner.ClassName ) - 3 )
             + Copy( Data.Name, 3, Length( Data.Owner.Name ) - 2 ) + 'Default';

end;
//======================================================================================================================
procedure LoadDefaultFromRegistry ( Data: TADODataSet );
  var Stream: TStream;
      Reader: TReader;
      Reg: TRegistry;
      Key, Sec: String;
      Buffer: String;
      i: Integer;
begin
  if ( Data.State <> dsInsert ) then Exit;
  Key := 'Software\TSK Developer Laboratory\' + Application.Title;
  Sec := GetSectorName( Data );
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey( Key, False );
    SetString( Buffer, nil, Reg.GetDataSize( Sec ));
    Reg.ReadBinaryData( Sec, PChar( Buffer )^, Length( Buffer ));
  finally
    Reg.Free;
  end;
  Stream := TStringStream.Create( Buffer );
  Stream.Position := 0;
  Reader := TReader.Create( Stream, $FF );
  for i := 0 to Data.FieldCount - 1 do
    if Data.Fields[i].HasConstraints then
      try
        Data.Fields[i].Value := Reader.ReadVariant;
      except
        if ( Data.Fields[i].DataType in [ ftDate, ftDateTime ] )
          then Data.Fields[i].AsDateTime := Trunc(Now)
          else Data.Fields[i].AsString := Data.Fields[i].DefaultExpression;
      end;
  Reader.Free;
  Stream.Free;
end;
//======================================================================================================================
procedure SaveDefaultToRegistry ( Data: TADODataSet );
  var Stream: TStream;
      Writer: TWriter;
      Reg: TRegistry;
      Key, Sec: String;
      Buffer: String;
      i: Integer;
begin
  Stream := TMemoryStream.Create;
  Writer := TWriter.Create( Stream, $FF );
  for i := 0 to Data.FieldCount - 1 do
    if Data.Fields[i].HasConstraints then Writer.WriteVariant( Data.Fields[i].Value );
  Writer.FlushBuffer;
  Stream.Position := 0;
  Key := 'Software\TSK Developer Laboratory\' + Application.Title;
  Sec := GetSectorName( Data );
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CURRENT_USER;
    Reg.OpenKey( Key, True);
    SetString( Buffer, nil, Stream.Size );
    Stream.ReadBuffer( PChar( Buffer )^, Stream.Size );
    Reg.WriteBinaryData( Sec , PChar( Buffer )^, Length( Buffer ));
  finally
    Reg.Free;
  end;
  Writer.Free;
  Stream.Free;
end;
//======================================================================================================================
procedure SetField( Field: TField; Value: Variant );
begin
  if Value <> null then begin
    if ( Field.Value <> Value ) then begin
      if not ( Field.DataSet.State in [ dsInsert, dsEdit ]) then Field.DataSet.Edit;
      Field.Value := Value;
    end;
  end else Field.Clear;
end;
//======================================================================================================================
procedure SetFieldPost( Field: TField; Value: Variant );
begin
  if not ( Field.DataSet.State in [ dsInsert, dsEdit ]) then Field.DataSet.Edit;
  if Value = null then Field.Clear else Field.Value := Value;
  Field.DataSet.Post;
end;
//======================================================================================================================
function GetField( Field: TField ): Variant;
begin
  if Field.DataSet.Active then Result := Field.Value else Result := null;
end;
//======================================================================================================================
procedure ClearDateSetField( Data: TADODataSet );
  var i: Integer;
begin
  if not ( Data.State in [ dsEdit, dsInsert ]) then Exit;
  for i := 0 to Data.FieldCount - 1 do
    if ( Data.Fields[i].DataType = ftString ) and Empty( Data.Fields[i].Value )
      then Data.Fields[i].Clear
end;
//======================================================================================================================
procedure SetStateEdit( Data: TADODataSet );
begin
  if not ( Data.State in [ dsEdit, dsInsert ]) then Data.Edit;
end;
//======================================================================================================================
procedure SetStateBrowse( Data: TADODataSet );
begin
  if ( Data.State in [ dsEdit, dsInsert ]) then Data.Post;
end;
//======================================================================================================================
function DataSetStateEnum ( Data: TADODataSet): String;
begin
  Result := 'dsUnknow';
  case Data.State of
    dsInactive:     Result := 'dsInactive';
    dsBrowse:       Result := 'dsBrowse';
    dsEdit:         Result := 'dsEdit';
    dsInsert:       Result := 'dsInsert';
    dsSetKey:       Result := 'dsSetKey';
    dsCalcFields:   Result := 'dsCalcFields';
    dsFilter:       Result := 'dsFilter';
    dsNewValue:     Result := 'dsNewValue';
    dsOldValue:     Result := 'dsOldValue';
    dsCurValue:     Result := 'dsCurValue';
    dsBlockRead:    Result := 'dsBlockRead';
    dsInternalCalc: Result := 'dsInternalCalc';
    dsOpening:      Result := 'dsOpening';
  end;
end;
//======================================================================================================================
{      }
//======================================================================================================================
function FloatToSQL( Value: Extended ): String;
  var OldSep: Char;
begin
{$IFDEF VER150} // D7
  OldSep := DecimalSeparator;
  DecimalSeparator := '.';
  Result := FloatToStr( Value );
  DecimalSeparator := OldSep;
{$ELSE} // XE
  OldSep := FormatSettings.DecimalSeparator;
  FormatSettings.DecimalSeparator := '.';
  Result := FloatToStr( Value );
  FormatSettings.DecimalSeparator := OldSep;
{$ENDIF}
end;
//======================================================================================================================
function DateToSQL( Value: TDateTime ): String;
begin
  Result := FormatDateTime('yyyymmdd', Value )
end;
//======================================================================================================================
end.
