{===================================================================================================

  Comming Library.

       .

====================================================================================================

  :

  28.01.2014 [*] .
  23.01.2004 [+]        Jpeg (75%).
             [+]    .
             [+] AutoSize   ZoomToFit.
  14.12.2003 [+] Inden:     .
             [+] AutoSize:   .
  10.12.2003 [*]  uses.
  29.11.2002 [*]    CommingDesign  CommingRuntime
  09.09.1998 [+]  Comming Library.

====================================================================================================
  Copyright 19982014 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingDBImage.pas,v 1.3 2019/03/28 08:29:05 tsk Exp $
===================================================================================================}
unit CommingDBImage;

interface

uses  Windows, Messages, Classes, Controls, DB, DBCtrls, Graphics, Math,
      // Comming:
      CommingColor;

type
  //Evento para cargar imgenes personalizadas desde el stream guardado
//  TLoadCustomImageEvent = procedure (var B: TGraphic; Stream: TStream)of object;

//  TImageResize = procedure( Height

  TcoDBImage = class(TCustomControl)
  private
    FDataLink: TFieldDataLink;
    FPicture: TPicture;
//    FBorderStyle: TBorderStyle;
    FAutoDisplay: Boolean;
//    FStretch: Boolean;
    FCenter: Boolean;
    FPictureLoaded: Boolean;
    FQuickDraw: Boolean;
    FZoomToFit: Boolean;
//    fOnLoadCustomImage: TLoadCustomImageEvent;
//    FAutoSize: Boolean;
//    FInden: Integer;
    procedure DataChange(Sender: TObject);
    function GetDataField: string;
    function GetDataSource: TDataSource;
    function GetField: TField;
    function GetReadOnly: Boolean;
    procedure PictureChanged(Sender: TObject);
//    procedure SetAutoDisplay(Value: Boolean);
//    procedure SetBorderStyle(Value: TBorderStyle);
    procedure   SetCenter(Value: Boolean);
    procedure   SetDataField(const Value: string);
    procedure   SetDataSource(Value: TDataSource);
    procedure   SetPicture(Value: TPicture);
    procedure   SetReadOnly(Value: Boolean);
//    procedure SetStretch(Value: Boolean);
//    procedure   coSetAutoSize(const Value: Boolean);
//    procedure   coSetInden(const Value: Integer);
//    procedure   coAutoSize;
    procedure   UpdateData(Sender: TObject);
    procedure   CMGetDataLink(var Message: TMessage); message CM_GETDATALINK;
    procedure   CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure   CMExit(var Message: TCMExit); message CM_EXIT;
    procedure   CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure   WMLButtonDown(var Message: TWMLButtonDown); message WM_LBUTTONDOWN;
//    procedure   WMLButtonDblClk(var Message: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
//    procedure   WMCut(var Message: TMessage); message WM_CUT;
    procedure   WMCopy(var Message: TMessage); message WM_COPY;
    procedure   WMPaste(var Message: TMessage); message WM_PASTE;
    procedure   WMSize(var Message: TMessage); message WM_SIZE;
    procedure   SetZoomToFit(const Value: Boolean);
    function    coPictureType: String;
  protected
    Memoria: TmemoryStream;
    procedure   CreateParams(var Params: TCreateParams); override;
    function    GetPalette: HPALETTE; override;
//    procedure   KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure   KeyPress(var Key: Char); override;
    procedure   Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure   Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure   CopyToClipboard;
//    procedure   CutToClipboard;
    function    ExecuteAction(Action: TBasicAction): Boolean; override;
    procedure   LoadPicture;
    procedure   PasteFromClipboard;
    function    UpdateAction(Action: TBasicAction): Boolean; override;
    property    Field: TField read GetField;
    property    Picture: TPicture read FPicture write SetPicture;
    procedure   LoadFromFile(const FileName: string);{v1.3}
    procedure   SaveToFile(const FileName: string); {v1.3}
  published
    property    Align;
    property    Anchors;
//    property BevelEdges;
//    property BevelInner default bvNone;
//    property BevelKind default bkTile;
//    property BevelOuter;
//    property BevelWidth default 2;
//    property AutoDisplay: Boolean read FAutoDisplay write SetAutoDisplay default True;
//    property BorderStyle: TBorderStyle read FBorderStyle write SetBorderStyle default bsNone;
//    property    AutoSize: Boolean read FAutoSize write coSetAutoSize default True;
//    property    Inden: Integer read FInden write coSetInden default 4;
    property    Center: Boolean read FCenter write SetCenter default True;
    property    Color;
    property    Constraints;
//    property Ctl3D;
    property    DataField: string read GetDataField write SetDataField;
    property    DataSource: TDataSource read GetDataSource write SetDataSource;
//    property    DragCursor;
//    property DragKind;
//    property DragMode;
//    property Enabled;
//    property Font;
//    property ParentColor default False;
//    property ParentCtl3D;
//    property ParentFont;
    property    ParentShowHint;
    property    PopupMenu;
    property    ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property    QuickDraw: Boolean read FQuickDraw write FQuickDraw default True;
    property    ShowHint;
//    property Stretch: Boolean read FStretch write SetStretch default False;
    property    TabOrder;
    property    TabStop default True;
    property    Visible;
    property    ZoomToFit: Boolean read FZoomToFit write SetZoomToFit default True;
    property    PictureType: String read coPictureType;
    property    OnClick;
    property    OnDblClick;
//    property OnContextPopup;
//    property OnDragDrop;
//    property OnDragOver;
//    property OnEndDock;
//    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
//    property OnStartDock;
//    property OnStartDrag;
//    property OnLoadCustomImage :TLoadCustomImageEvent read fOnLoadCustomImage write fOnLoadCustomImage;
  end;

//  procedure Register;

implementation

uses Clipbrd, JPeg;

//==================================================================================================
{ TcoDBImage }
//==================================================================================================
constructor TcoDBImage.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csOpaque, csReplicatable];
  if not NewStyleControls then ControlStyle := ControlStyle + [csFramed];
  Width                   := 105;
  Height                  := 105;
  TabStop                 := True;
  ParentColor             := False;
  FPicture                := TPicture.Create;
  FPicture.OnChange       := PictureChanged;
  BevelKind               := bkTile;
  BevelInner              := bvNone;
  Color                   := ComponentColor( Self );
  BevelWidth              := 2;
  FAutoDisplay            := True;
//  FAutoSize               := True;
//  FInden                  := 4;
  FZoomToFit              := True;
  FCenter                 := True;
  FDataLink               := TFieldDataLink.Create;
  FDataLink.Control       := Self;
  FDataLink.OnDataChange  := DataChange;
  FDataLink.OnUpdateData  := UpdateData;
  FQuickDraw              := True;
  Memoria                 := TmemoryStream.Create;
end;
//==================================================================================================
destructor TcoDBImage.Destroy;
begin
  FPicture.Free;
  FDataLink.Free;
  FDataLink := nil;
  Memoria.Free;
  inherited Destroy;
end;
//==================================================================================================
procedure TcoDBImage.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  with Params do begin
{    if FBorderStyle = bsSingle then
      if NewStyleControls and Ctl3D then
        ExStyle := ExStyle or WS_EX_CLIENTEDGE
      else
        Style := Style or WS_BORDER;}
    WindowClass.style := WindowClass.style and not (CS_HREDRAW or CS_VREDRAW);
  end;
end;
//==================================================================================================
function TcoDBImage.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;
//==================================================================================================
procedure TcoDBImage.SetDataSource(Value: TDataSource);
begin
  if not (FDataLink.DataSourceFixed and (csLoading in ComponentState)) then
    FDataLink.DataSource := Value;
  if Value <> nil then Value.FreeNotification(Self);
end;
//==================================================================================================
function TcoDBImage.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;
//==================================================================================================
procedure TcoDBImage.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;
//==================================================================================================
function TcoDBImage.GetReadOnly: Boolean;
begin
  Result := FDataLink.ReadOnly;
end;
//==================================================================================================
procedure TcoDBImage.SetReadOnly(Value: Boolean);
begin
  FDataLink.ReadOnly := Value;
end;
//==================================================================================================
function TcoDBImage.GetField: TField;
begin
  Result := FDataLink.Field;
end;
//==================================================================================================
function TcoDBImage.GetPalette: HPALETTE;
begin
  Result := 0;
  if FPicture.Graphic <> nil then
     Result := FPicture.Graphic.Palette;
{TGraphic has a property Pallete read GetPalette. and GetPalette is Virtual
Desendants re-implements GetPalette so I don't need ask what kind of Graphic is stored}
end;
//==================================================================================================
{procedure TcoDBImage.SetAutoDisplay(Value: Boolean);
begin
  if FAutoDisplay <> Value then
    begin
    FAutoDisplay := Value;
    if Value then LoadPicture;
    end;
end;}

{procedure TcoDBImage.SetBorderStyle(Value: TBorderStyle);
begin
  if FBorderStyle <> Value then
  begin
    FBorderStyle := Value;
    RecreateWnd;
  end;
end;                    }
//==================================================================================================
procedure TcoDBImage.SetCenter(Value: Boolean);
begin
  if FCenter <> Value then begin
    FCenter := Value;
    Invalidate;
  end;
end;
//==================================================================================================
procedure TcoDBImage.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
//  coAutoSize;
end;
//==================================================================================================
{procedure TcoDBImage.SetStretch(Value: Boolean);
begin
  if FStretch <> Value then begin
    FStretch := Value;
    Invalidate;
  end;
end;}
//==================================================================================================
procedure TcoDBImage.Paint;
var
  Size: TSize;
  R: TRect;
  S: string;
  DrawPict: TPicture;
//  Form: TCustomForm;
  Pal: HPalette;
  dp: Single;
begin
//  coAutoSize; // TSK
  with Canvas do
    begin
    Brush.Style := bsSolid;
    Brush.Color := Color;
    FillRect(ClientRect);
    if FPictureLoaded or (csPaintCopy in ControlState) then
      begin
      DrawPict := TPicture.Create;
      Pal := 0;
      try
        if (csPaintCopy in ControlState) and Assigned(FDataLink.Field) and FDataLink.Field.IsBlob then
          begin
          DrawPict.Assign(FDataLink.Field);
          if DrawPict.Graphic is TBitmap then
            DrawPict.Bitmap.IgnorePalette := QuickDraw;
          end
        else
          begin
          DrawPict.Assign(Picture);
          if Focused and (DrawPict.Graphic <> nil) and (DrawPict.Graphic.Palette <> 0) then begin
            { Control has focus, so realize the bitmap palette in foreground }
            Pal := SelectPalette(Handle, DrawPict.Graphic.Palette, False);
            RealizePalette(Handle);
          end;
        end;
{        if Stretch then
          if (DrawPict.Graphic = nil) or DrawPict.Graphic.Empty then
            FillRect(ClientRect)
          else
            //   
            StretchDraw(ClientRect, DrawPict.Graphic)
        else}
          begin

//          SetRect(R, 0, 0, min(DrawPict.Width, ClientWidth), DrawPict.Height); //TSK

          if FZoomToFit
              and (( DrawPict.Width > ClientWidth ) or ( DrawPict.Height > ClientHeight )) then begin
            dp := min ( ClientWidth / DrawPict.Width, ClientHeight / DrawPict.Height );
            SetRect(R, 0, 0, Trunc(DrawPict.Width * dp), Trunc(DrawPict.Height * dp));
          end else begin
            SetRect(R, 0, 0, DrawPict.Width, DrawPict.Height);
          end;
          if Center then
            OffsetRect(R, (ClientWidth - R.Right - R.Left) div 2, (ClientHeight - R.Bottom - R.Top) div 2);
//            OffsetRect(R, (ClientWidth - DrawPict.Width) div 2, (ClientHeight - DrawPict.Height) div 2);
          StretchDraw(R, DrawPict.Graphic);
//          ExcludeClipRect(Handle, R.Left, R.Top, R.Right, R.Bottom);
//          FillRect(ClientRect);
//          SelectClipRgn(Handle, 0);
        end;
      finally
        if Pal <> 0 then SelectPalette(Handle, Pal, True);
        DrawPict.Free;
      end;
      end
    else
      begin
      Font := Self.Font;
      if FDataLink.Field <> nil then
        S := FDataLink.Field.DisplayLabel
      else
        S := Name;
      S := '(' + S + ')';
      Size := TextExtent(S);
      R := ClientRect;
      TextRect(R, (R.Right - Size.cx) div 2, (R.Bottom - Size.cy) div 2, S);
      end;
{    Form := GetParentForm(Self);
    if (Form <> nil) and (Form.ActiveControl = Self) and
       not (csDesigning in ComponentState) and not (csPaintCopy in ControlState) then
      begin}
    if Focused then begin
      Brush.Color := clWindowFrame;
      FrameRect(ClientRect);
    end;
  end;
end;
//==================================================================================================
procedure TcoDBImage.PictureChanged(Sender: TObject);
begin
  if FPictureLoaded then FDataLink.Modified;
  FPictureLoaded := True;
  Invalidate;
end;
//==================================================================================================
procedure TcoDBImage.Notification(AComponent: TComponent;  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end;
//==================================================================================================
procedure TcoDBImage.LoadPicture;
  var B: TGraphic;
      Buf: word;
begin
  B := nil;
  with fDatalink do
    if (Field = nil) or not Field.IsBlob or Field.IsNull then begin
      Picture.Assign(Nil);
      Exit;
    end;
    if not FPictureLoaded and (not Assigned(FDataLink.Field) or FDataLink.Field.IsBlob) then
      try
        Memoria.Clear;
        TBlobField(Field).SaveToStream(Memoria);
        Memoria.Position :=0;
        if Memoria.Size > SizeOf(buf) then begin
          Memoria.read(buf, SizeOf(buf));
          case buf of
            $0000: B := TIcon.Create;
            $0001: begin
                     Picture.Assign(FDataLink.Field);
                     Exit;
                    end;
            $4D42: B := TBitmap.Create;
            $CDD7: B := TMetafile.Create;
            $D8FF: B := TJPEGImage.Create;
          end;
        end;
        Memoria.Position := 0;
        if B <> nil then
          try
            B.LoadFromStream(Memoria);
          except
            B := nil;
          end;
//if the stored image is not ico, bmp, wmf, emf, jpg, jpeg
//or I cant load it then fire the event
{    if (b = nil) and Assigned(fonloadCustomImage) then
      try
        memoria.Position := 0;
        fOnLoadCustomImage(B, Memoria);
      except
        B:= nil;
      end;}

        Picture.Assign(B);//B can be NIL, no problem with that
// TSK
{        if FAutoSize then begin
          Constraints.MinWidth := Picture.Width + ( FInden * 2 );
          Constraints.MinHeight := Picture.Height + ( FInden * 2 );
        end;}
      finally
        B.Free;
        Memoria.Clear;
      end;
end;
//==================================================================================================
procedure TcoDBImage.DataChange(Sender: TObject);
begin
  Picture.Graphic := nil;
  FPictureLoaded := False;
  if FAutoDisplay then LoadPicture;
end;
//==================================================================================================
procedure TcoDBImage.UpdateData(Sender: TObject);
  var MS: TMemoryStream;
begin
  if (Picture.Graphic is TBitmap) then
     FDataLink.Field.Assign(Picture.Graphic)
  else
    begin
    MS := TMemoryStream.Create;
    try
      try
        Ms.Clear;
        Picture.Graphic.SaveToStream(MS);
        Ms.Position := 0;
        TBlobField(Fdatalink.field).LoadFromStream(MS);
      except
        FDataLink.Field.Clear;
      end;
    finally
    Ms.Free;
    end;
    end;
end;
//==================================================================================================
procedure TcoDBImage.CopyToClipboard;
begin
  if Picture.Graphic <> nil then
    Clipboard.Assign(Picture);
end;
//==================================================================================================
{procedure TcoDBImage.CutToClipboard;
begin
  if Picture.Graphic <> nil then
    if FDataLink.Edit then
    begin
      CopyToClipboard;
      Picture.Graphic := nil;
      PictureChanged(Self);
    end;
end;}
//==================================================================================================
procedure TcoDBImage.PasteFromClipboard;
  var JP: TJPEGImage;
      BP: TBitmap;
begin
  if fDatalink.edit then
    if ClipBoard.HasFormat(CF_BITMAP) then begin
      BP := TBitmap.Create;
      BP.Assign( Clipboard );
      JP := TJPEGImage.Create;
      JP.Assign( BP );
      Picture.Assign( JP )
//     Picture.Bitmap.Assign(Clipboard)
    end else
      if ClipBoard.HasFormat(CF_METAFILEPICT)or ClipBoard.HasFormat(CF_ENHMETAFILE) then
        picture.Metafile.Assign(ClipBoard)
      else
        if ClipBoard.hasformat(Cf_picture) then
          picture.Assign(ClipBoard);
  PictureChanged(Self);
end;
//==================================================================================================
{procedure TcoDBImage.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  case Key of
    VK_INSERT:  if ssShift in Shift then
                   PasteFromClipBoard
                else
                  if ssCtrl in Shift then
                    CopyToClipBoard;
    VK_DELETE:  if ssShift in Shift then
                  CutToClipBoard;
  end;
end;    }
//==================================================================================================
procedure TcoDBImage.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  case Key of
//    ^X: CutToClipBoard;
    ^C: CopyToClipBoard;
    ^V: PasteFromClipBoard;
//    #13: LoadPicture;
    #27: FDataLink.Reset;
  end;
end;
//==================================================================================================
procedure TcoDBImage.CMGetDataLink(var Message: TMessage);
begin
  Message.Result := Integer(FDataLink);
end;
//==================================================================================================
procedure TcoDBImage.CMEnter(var Message: TCMEnter);
begin
  Invalidate; { Draw the focus marker }
  inherited;
end;
//==================================================================================================
procedure TcoDBImage.CMExit(var Message: TCMExit);
begin
  try
    FDataLink.UpdateRecord;
  except
    SetFocus;
    raise;
  end;
  Invalidate; { Erase the focus marker }
  inherited;
end;
//==================================================================================================
procedure TcoDBImage.CMTextChanged(var Message: TMessage);
begin
  inherited;
  if not FPictureLoaded then Invalidate;
end;
//==================================================================================================
procedure TcoDBImage.WMLButtonDown(var Message: TWMLButtonDown);
begin
  if TabStop and CanFocus then SetFocus;
  inherited;
end;
//==================================================================================================
{procedure TcoDBImage.WMLButtonDblClk(var Message: TWMLButtonDblClk);
begin
  LoadPicture;
  inherited;
end;}
//==================================================================================================
{procedure TcoDBImage.WMCut(var Message: TMessage);
begin
  CutToClipboard;
end;}
//==================================================================================================
procedure TcoDBImage.WMCopy(var Message: TMessage);
begin
  CopyToClipboard;
end;
//==================================================================================================
procedure TcoDBImage.WMPaste(var Message: TMessage);
begin
  PasteFromClipboard;
end;
//==================================================================================================
procedure TcoDBImage.WMSize(var Message: TMessage );
begin
  inherited;
  Invalidate;
end;
//==================================================================================================
function TcoDBImage.ExecuteAction(Action: TBasicAction): Boolean;
begin
  Result := inherited ExecuteAction(Action) or (FDataLink <> nil) and
    FDataLink.ExecuteAction(Action);
end;
//==================================================================================================
function TcoDBImage.UpdateAction(Action: TBasicAction): Boolean;
begin
  Result := inherited UpdateAction(Action) or (FDataLink <> nil) and
    FDataLink.UpdateAction(Action);
end;
//==================================================================================================
procedure TcoDBImage.LoadFromFile(const FileName: string);
begin
  if Assigned(fDatalink.Field) and fDatalink.Field.IsBlob and fDatalink.Edit then
    TBlobField(fDatalink.Field).LoadFromFile(FileName);
end;
//==================================================================================================
procedure TcoDBImage.SaveToFile(const FileName: string);
begin
   if FPictureLoaded and Assigned(FDataLink.Field) and FDataLink.Field.IsBlob then
     TBlobField(fDatalink.Field).SaveToFile(FileName);
end;
//==================================================================================================
{procedure TcoDBImage.coSetAutoSize(const Value: Boolean);
begin
  FAutoSize := Value;
  coAutoSize;
end;}
//==================================================================================================
{procedure TcoDBImage.coSetInden(const Value: Integer);
begin
  FInden := Value;
//  coAutoSize;
end;}
//==================================================================================================
{procedure TcoDBImage.coAutoSize;
begin
  if (FPicture <> nil) and FAutoSize then begin
    Constraints.MinWidth := Picture.Width + ( FInden * 2 );
    Constraints.MinHeight := Picture.Height + ( FInden * 2 );
  end;
end;}
//==================================================================================================
procedure TcoDBImage.SetZoomToFit(const Value: Boolean);
begin
  if FZoomToFit <> Value then begin
    FZoomToFit := Value;
    Invalidate;
  end;
end;
//==================================================================================================
function TcoDBImage.coPictureType: String;
begin

end;
//==================================================================================================
end.
