{=======================================================================================================================

  Comming Library.

     .

========================================================================================================================

  :

  23.08.2020 [+] TcoDBEdit,SavedText:     .
  22.08.2020 [*] TcoDBEdit,SaveText:      .
  20.08.2020 [+] TcoEdit,AddClipboard:     .
  15.08.2020 [+] TcoDBEdit,AddClipboard:     .
             [+] TcoDBEdit,SaveText:     .
  28.11.2015 [+] TcoListBox.AddLastLine, TcoListBox.UpdateLastLine.
  27.11.2015 [+] TcoListBox.HorizontalLine.
  26.05.2015 [-] TcoDBEdit, TcoDBMemo, TcoMemo:     (  Unicode).
  25.05.2015 [+] TcoDBEdit, TcoDBMemo, TcoMemo:     (  Unicode).
  16.11.2011 [+] TcoMemo.AddLineFormat:   .
  01.09.2007 [*] .
  02.08.2004 [+] TcoLabel:    .
  09.05.2004 [+] TcoDBRichEdit:  RTF   .
  03.12.2003 [*]     .
  05.06.2003 [*] TcoTreeView:  scrollbar.
  16.03.2003 [*] TcoListBox: BevelWidth.
  29.11.2002 [*]    CommingDesign  CommingRuntime
  10.10.2002 [+] TcoLabel:  -.
             [+] TcoDBEdit:  -.
             [-]  .
             [+] TcoEdit: ,  -.
  29.08.2002 [+] TcoCheckListBox: .
  07.08.2002 [+] TcoListBox: Color.
  23.06.2002 [+] TcoDBMemo: Color.
  28.04.2002 [-] TcoDBImage:      JPEG  GIF.
  14.03.2002 [+] TcoDBEdit: Enabled -  .
  05.12.2001 [+] TcoLabel:  -.
  27.11.2001 [*] TcoLabel: ,  Caption     ( Win9x).
  11.09.2001 [*]   TcoTreeView.
  14.08.2001 [*] TcoLabel:   .
  02.07.2001 [*]   Delphi6.
  13.06.2001 [+] TcoEdit: Enabled -  .
  17.05.2001 [*] TcoLable:   TCustomLabel.
  08.05.2001 [+] TcoLable: 
  18.01.2000 [*] TcoEdit:   "" .
             [+] TcoDBEdit:  ReadOnly -  .
             [+] TcoDBEdit:  ReadOnlyColor -   .
             [-] TcoDBMemo:   Flat;
             [*] TcoDBMemo:   "" ;
             [*] TcoDBMemo:  ReadOnly -  ;
             [*] TcoDBMemo:  ReadOnlyColor -   .
             [-] TcoDBImage:   Flat;
             [*] TcoDBImage:   "" ;
             [*] TcoDBImage:  ReadOnly -  ;
             [*] TcoDBImage:  ReadOnlyColor -   .
             [-]  .
  17.01.2001 [*] TcoDBEdit ( ).
  16.01.2001 [-] TcoTreeView,   Flat.
  14.01.2001 [*] TcoEdit ( ).
  12.01.2000 [*] TcoEdit (  "" ).
  22.12.2000 [*] TcoDBEdit (  "" ).
             [*] TcoEdit (  "" ).
             [+]    "" .
  16.12.2000 [+]   "" .
             [+] TcoDBMemo ().
             [+] TcoDBImage ().
  15.12.2000 [+] TcoEdit ().
             [+] TcoDBEdit ().
             [+] TcoTreeView ().
             [+]  .  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982020 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingFlat.pas,v 1.12 2020/08/27 17:15:45 tsk Exp $
=======================================================================================================================}
unit CommingFlat;

interface

uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, DBCtrls,
      ComCtrls, CheckLst, DB,
      // Comming:
      CommingColor, CommingOther, CommingString;

type

  TOnCheck = procedure( Sender: TObject; Value: Variant; var Valid: Boolean ) of object;

{ TcoEdit }
  TcoEdit = class( TEdit )
  private     { Private declarations }
    function    GetReadOnly: Boolean;
    procedure   SetReadOnly( const Value: Boolean );
    function    GetEnabled_: Boolean;
    procedure   SetEnabled_( const Value: Boolean );
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   AddClipboard;
  published   { Published declarations }
    property    BevelInner default bvNone;
    property    BevelKind default bkTile;
    property    BorderStyle default bsNone;
    property    BevelWidth default 2;
    property    Height default 20;
    property    ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property    Enabled: Boolean read GetEnabled_ write SetEnabled_ default True;
  end;

{ TcoDBEdit }
  TcoDBEdit = class( TDBEdit )
  private     { Private declarations }
    FOnCheck: TOnCheck;
    function    GetReadOnly: Boolean;
    procedure   SetReadOnly(const Value: Boolean);
    function    GetEnabled_: Boolean;
    procedure   SetEnabled_(const Value: Boolean);
//    procedure   WMCopy(var Message: TMessage); message WM_COPY;
//    procedure   WMPaste(var Message: TMessage); message WM_PASTE;
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    function    Check: Boolean;
    function    SavedText: String;
    procedure   SaveText;
    procedure   AddClipboard;
  published   { Published declarations }
    property    BevelInner default bvNone;
    property    BevelKind default bkTile;
    property    BorderStyle default bsNone;
    property    BevelWidth default 2;
    property    Height default 20;
    property    ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
    property    Enabled: Boolean read GetEnabled_ write SetEnabled_ default True;
    property    OnCheck: TOnCheck read FOnCheck write FOnCheck;
  end;

{ TcoTreeView }
  TcoTreeView = class( TCustomTreeView )
  private     { Private declarations }
  protected   { Protected declarations }
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published   { Published declarations }
    property Align;
    property Anchors;
    property AutoExpand;
    property ChangeDelay;
    property Color;
    property Constraints;
    property DragKind;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property HotTrack;
    property Images;
    property Indent;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ReadOnly;
    property RightClickSelect;
    property RowSelect;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property SortType;
    property StateImages;
    property TabOrder;
    property TabStop default True;
    property ToolTips;
    property Visible;
    property OnAddition;
    property OnAdvancedCustomDraw;
    property OnAdvancedCustomDrawItem;
    property OnChange;
    property OnChanging;
    property OnClick;
    property OnCollapsed;
    property OnCollapsing;
    property OnCompare;
    property OnContextPopup;
    property OnCreateNodeClass;
    property OnCustomDraw;
    property OnCustomDrawItem;
    property OnDblClick;
    property OnDeletion;
    property OnDragDrop;
    property OnDragOver;
    property OnEdited;
    property OnEditing;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnExpanding;
    property OnExpanded;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
    { Items must be published after OnGetImageIndex and OnGetSelectedIndex }
    property Items;
  end;

{ TcoMemo }
  TcoMemo = class( TMemo )
  private   { Private declarations }
//    procedure   WMCopy(var Message: TMessage); message WM_COPY;
//    procedure   WMPaste(var Message: TMessage); message WM_PASTE;
  protected { Protected declarations }
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   AddLineFormat( const Formats: string; const Args: array of const );
  published { Published declarations }
    property    BevelInner default bvNone;
    property    BevelKind default bkTile;
    property    BorderStyle default bsNone;
    property    ScrollBars default ssVertical;
  end;

{ TcoDBMemo }
  TcoDBMemo = class( TDBMemo )
  private     { Private declarations }
    function    GetReadOnly: Boolean;
    procedure   SetReadOnly( const Value: Boolean );
//    procedure   WMCopy(var Message: TMessage); message WM_COPY;
//    procedure   WMPaste(var Message: TMessage); message WM_PASTE;
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published   { Published declarations }
    property    BevelInner default bvNone;
    property    BevelKind default bkTile;
    property    BorderStyle default bsNone;
    property    ReadOnly: Boolean read GetReadOnly write SetReadOnly default False;
  end;

{ TcoDBRichEdit }
  TcoDBRichEdit = class(TDBRichEdit)
  private     { Private declarations }
  protected
  public      { Public declarations }
    constructor   Create(AOwner: TComponent); override;
  published   { Published declarations }
    property      BevelInner default bvNone;
    property      BevelKind default bkTile;
    property      BorderStyle default bsNone;
  end;

{ TcoLabel }
  TcoLabel = class( TCustomLabel )
  private   { Private declarations }
    FOnTextChanged: TNotifyEvent;
    function    GetWidthText: Integer;
    procedure   CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
  protected   { Protected declarations }
  public      { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published   { Published declarations }
    property    Align;
    property    Alignment default taRightJustify;
    property    Anchors;
    property    AutoSize default False;
    property    Caption;
    property    Color ;
    property    Constraints;
    property    Enabled;
    property    FocusControl;
    property    Font;
    property    Height default 20;
    property    ParentColor;
    property    ParentFont;
    property    ParentShowHint;
    property    ShowHint;
    property    Transparent;
    property    Layout default tlCenter;
    property    Visible;
    property    WordWrap;
    property    WidthText: Integer read GetWidthText stored False;
    property    OnClick;
    property    OnContextPopup;
    property    OnDblClick;
    property    OnTextChanged: TNotifyEvent read FOnTextChanged write FOnTextChanged;
  end;

{ TcoListBox }
  TcoListBox = class(TListBox)
  private   { Private declarations }
  protected { Protected declarations }
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published { Published declarations }
    property    BevelWidth;
    procedure   AddLastLine( line: String );
    procedure   HorizontalLine;
    procedure   UpdateLastLine( line: String );
  end;

{ TcoCheckListBox }
  TcoCheckListBox = class(TCheckListBox)
  private   { Private declarations }
  protected { Protected declarations }
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
  published { Published declarations }
  end;

  procedure RepaintFlatBorder( Handle: HWND );

//  procedure Register;

implementation
//======================================================================================================================
procedure RepaintFlatBorder( Handle: HWND );
  var DC : HDC;
      aRect : TRect;
begin
  DC := GetWindowDC( Handle );
  try
    GetWindowRect( Handle, aRect );
    OffsetRect( aRect, -aRect.Left, -aRect.Top );
    DrawEdge( DC, aRect, BDR_SUNKENOUTER, BF_RECT )
  finally
    ReleaseDC( Handle, DC);
  end;
end;
//======================================================================================================================
{ TcoEdit }
//======================================================================================================================
constructor TcoEdit.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  Color           := ComponentColor( Self );// clDimWindow;
  BevelWidth      := 2;
  Height          := 20;
end;
//======================================================================================================================
procedure TcoEdit.AddClipboard;
  var c: String;
begin
  c := GetStringFromClipboard;
  if not ( c = EmptyStr) then
    if Text = EmptyStr
      then Text := c
      else Text := Text + ' & ' + c;
end;
//======================================================================================================================
function TcoEdit.GetEnabled_: Boolean;
begin
  Result := inherited Enabled;
end;
//======================================================================================================================
function TcoEdit.GetReadOnly: Boolean;
begin
  Result := inherited ReadOnly;
end;
//======================================================================================================================
procedure TcoEdit.SetEnabled_(const Value: Boolean);
begin
  inherited Enabled := Value;
  if Enabled and not ReadOnly then Color := ComponentColor( Self ){clDimWindow} else color := clBtnFace;
  RecreateWnd;
end;
//======================================================================================================================
procedure TcoEdit.SetReadOnly( const Value: Boolean );
begin
  inherited ReadOnly := Value;
  if Enabled and not ReadOnly then Color := ComponentColor( Self ){clDimWindow} else color := clBtnFace;
  RecreateWnd;
end;
//======================================================================================================================
{ TcoDBEdit }
//======================================================================================================================
constructor TcoDBEdit.Create( AOwner: TComponent );
begin
  inherited Create(AOwner);
  BorderStyle := bsNone;
  BevelKind   := bkTile;
  BevelInner  := bvNone;
  if not ( csDesigning in ComponentState ) then begin
    Color     := clDimWindow;
  end;
  BevelWidth  := 2;
  Height      := 20;
//  RecreateWnd;
end;
//======================================================================================================================
function TcoDBEdit.GetReadOnly: Boolean;
begin
  Result := inherited ReadOnly;
end;
//======================================================================================================================
procedure TcoDBEdit.SetReadOnly( const Value: Boolean );
begin
  inherited ReadOnly := Value;
  if Value
    then Color := clBtnFace
    else if ( csDesigning in ComponentState )
      then Color := clWindow
      else Color := clDimWindow;
  RecreateWnd;
end;
//======================================================================================================================
function TcoDBEdit.GetEnabled_: Boolean;
begin
  Result := inherited Enabled;
end;
//======================================================================================================================
procedure TcoDBEdit.SetEnabled_(const Value: Boolean);
begin
  inherited Enabled := Value;
  if Enabled and not ReadOnly then Color := clDimWindow else color := clBtnFace;
  RecreateWnd;
end;
//======================================================================================================================
function TcoDBEdit.Check: Boolean;
begin
  if Focused then Field.Text := Text;
  if Assigned( FOnCheck ) and ( Field <> nil )
    then FOnCheck( Self, Field.Value, Result )
    else Result := True;
  if not Result then SetFocusShowHint( Self );
end;
//======================================================================================================================
procedure TcoDBEdit.SaveText;
begin
  if ( Text = EmptyStr )
    then Field.Clear
    else Field.Text := Text;
end;
//======================================================================================================================
function TcoDBEdit.SavedText: String;
begin
  if ( Text = EmptyStr )
    then Field.Clear
    else Field.Text := Text;
  Result := Text;
end;
//======================================================================================================================
procedure TcoDBEdit.AddClipboard;
  var c: String;
begin
  if not ( Field.DataSet.State in [ dsEdit, dsInsert ]) then Field.DataSet.Edit;
  Field.Text := Text;
  c := GetStringFromClipboard;
  if not ( c = EmptyStr) then
    if Field.Text = EmptyStr
      then Field.Text := c
      else Field.Text := Field.Text + ' & ' + c;
end;
//======================================================================================================================
{ TcoTreeView }
//======================================================================================================================
constructor TcoTreeView.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  BorderStyle := bsNone;
  BevelKind   := bkTile;
  BevelInner  := bvNone;
end;
//======================================================================================================================
{ TcoMemo }
//======================================================================================================================
constructor TcoMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  ScrollBars      := ssVertical;
  if not ( csDesigning in ComponentState ) then begin
    Color         := clDimWindow;
  end;
end;
//======================================================================================================================
procedure TcoMemo.AddLineFormat(const Formats: string; const Args: array of const);
begin
  Self.Lines.Add( Format( Formats, Args ));
end;
//======================================================================================================================
{procedure TcoMemo.WMCopy(var Message: TMessage);
begin
  if SelText = EmptyStr
    then PutStringIntoClipBoard( Text )
    else PutStringIntoClipBoard( SelText )
end;
//======================================================================================================================
procedure TcoMemo.WMPaste(var Message: TMessage);
begin
  if SelText = EmptyStr
    then Text := GetStringFromClipboard
    else SelText := GetStringFromClipboard;
end;}
//======================================================================================================================
{ TcoDBMemo }
//======================================================================================================================
constructor TcoDBMemo.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  if not ( csDesigning in ComponentState ) then begin
    Color         := clDimWindow;
  end;
end;
//======================================================================================================================
function TcoDBMemo.GetReadOnly: Boolean;
begin
  Result := inherited ReadOnly;
end;
//======================================================================================================================
procedure TcoDBMemo.SetReadOnly( const Value: Boolean );
begin
  if Value then begin
    Color := clBtnFace
  end else if not ( csDesigning in ComponentState ) then begin
    Color := clDimWindow;
  end else begin
    Color := clWindow;
  end;
  RecreateWnd;
  inherited ReadOnly := Value;
end;
//======================================================================================================================
{procedure TcoDBMemo.WMCopy(var Message: TMessage);
begin
  if SelText = EmptyStr
    then PutStringIntoClipBoard( Text )
    else PutStringIntoClipBoard( SelText )
end;
//======================================================================================================================
procedure TcoDBMemo.WMPaste(var Message: TMessage);
begin
  if SelText = EmptyStr
    then Text := GetStringFromClipboard
    else SelText := GetStringFromClipboard;
end;}
//======================================================================================================================
{ TcoDBRichEdit }
//======================================================================================================================
constructor TcoDBRichEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  if not ( csDesigning in ComponentState ) then begin
    Color         := clDimWindow;
  end;
end;
//======================================================================================================================
{ TcoLabel }
//======================================================================================================================
constructor TcoLabel.Create( AOwner: TComponent );
begin
  inherited Create( AOwner );
  Alignment := taRightJustify;
  AutoSize  := False;
  Height    := 20;
  Layout    := tlCenter;
end;
//======================================================================================================================
function TcoLabel.GetWidthText: Integer;
begin
  Canvas.Font := Self.Font;
  Result      := Canvas.TextWidth( Caption );
end;
//======================================================================================================================
procedure TcoLabel.CMTextChanged( var Message: TMessage );
begin
  inherited;
  if Assigned(FOnTextChanged) then FOnTextChanged(Self);
end;
//======================================================================================================================
{ TcoListBox }
//======================================================================================================================
constructor TcoListBox.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  if not ( csDesigning in ComponentState ) then begin
    Color         := clDimWindow;
  end;
end;
//======================================================================================================================
procedure TcoListBox.AddLastLine( line: String );
begin
  Items.Add( line );
  ItemIndex := (Items.Count - 1)
end;
//======================================================================================================================
procedure TcoListBox.HorizontalLine;
  var l: String;
  const c = #151;
begin
  Canvas.Font := Font;
  l := c;
  while ClientWidth > Canvas.TextWidth( l ) do l := l + c;
  AddLastLine( Copy( l, 2, MaxInt ));
end;
//======================================================================================================================
procedure TcoListBox.UpdateLastLine( line: String );
begin
  ItemIndex := (Items.Count - 1);
  Items[Items.Count - 1] := line;
end;
//======================================================================================================================
{ TcoCheckListBox }
//======================================================================================================================
constructor TcoCheckListBox.Create(AOwner: TComponent);
begin
  inherited Create( AOwner );
  BorderStyle     := bsNone;
  BevelKind       := bkTile;
  BevelInner      := bvNone;
  BevelWidth      := 2;
  if not ( csDesigning in ComponentState ) then begin
    Color         := clDimWindow;
  end;
end;
//======================================================================================================================
end.
