{=======================================================================================================================

  Comming Library

     Internet.

========================================================================================================================

  :

  26.01.2021 [+] NormalizationURL: last.fm.
  18.08.2020 [+] NormalizationURL: records.su.
  10.08.2020 [+] InternetExplorer:       .
  23.07.2020 [*] GetHTML:   D7.
  12.12.2019 [+] GetHTML: https.    .
  08.08.2019 [+] NormalizationURL: youtu.be.
             [+] YouTubeWatch, YouTubeEmbed:     .
             [+] NormalizationURL: www.youtube.com/watch.
  05.07.2019 [+] GetHTML:   .
  27.03.2019 [*] SiteMap:   ( ).
  25.10.2018 [*]  uses  Delphi 7.
  24.10.2018 [+] SiteMap:    .
  18.10.2018 [+] NormalizationURL: www.youtube.com/embed.
  14.08.2017 [+] NormalizationURL: kinopoisk.ru.
  11.07.2017 [*] NormalizationURL:  imdb.com.
  27.06.2017 [*] ExtractHost:  www.
  11.01.2017 [+] NormalizationURL:   .
  12.12.2016 [+] NormalizationURL: imdb.com.
  11.12.2016 [+] NormalizationURL:  URL  (discogs.com, allmusic.com)   .
  31.12.2015 [*] ExtractHost:  www.
  05.05.2007 [+] ExtractHost:   .
             [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982021 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingInternet.pas,v 1.21 2021/01/26 04:49:08 tsk Exp $
=======================================================================================================================}
unit CommingInternet;

interface

  uses  SysUtils, Windows, StrUtils, Classes,
        IdHTTP, IdIOHandler, IdIOHandlerSocket, IdSSLOpenSSL,
        CommingFile, CommingString, CommingSystem;

  function InternetExplorer: String;
  function ExtractHost( URL: String ): String;
  function NormalizationURL( URL: String ): String;
  function YouTubeWatch( URL: String ): String;
  function YouTubeEmbed( URL: String ): String;
  function SiteMap( Path, Ext, Skip, URL, Map: String ): Integer;
  {$IFDEF VER150} // D7
  function GetHTML( URL: String ): String;
  {$ENDIF}

implementation
//======================================================================================================================
function InternetExplorer: String;
begin
  Result := 'iexplore.exe';
  if IsWindows10 then Result := 'msedge.exe'
end;
//======================================================================================================================
function ExtractHost( URL: String ): String;
  var p: Integer;
begin
  p := Pos( '//', URL );
  if p > 0 then URL := Copy( URL, p + 2, Length( URL ));
  p := Pos( '/', URL );
  if p > 0 then URL := Copy( URL, 1, p - 1 );
  p := Pos( 'www', URL );
  if p > 0 then begin
    URL := Copy( URL, p + 3, MaxInt );
    p := Pos( '.', URL );
    URL := Copy( URL, p + 1, MaxInt );
  end;
  Result := URL;
end;
//======================================================================================================================
function NormalizationURL( URL: String ): String;
  var s, r: String;
begin
  s := URL;
  if Pos( 'www.discogs.com', url ) > 0 then begin
    if Pos( 'artist', url ) > 0
      then url := Copy( url, 1, Pos( '-', url ) - 1 );
    if Pos( 'master', url ) > 0
      then url := Copy( url, 1, Pos( 'com/', url ) + 3 ) + Copy( url, Pos( 'master', url ), MaxInt );
    if Pos( 'release', url ) > 0
      then url := Copy( url, 1, Pos( 'com/', url ) + 3 ) + Copy( url, Pos( 'release', url ), MaxInt );
    if Pos( 'label', url ) > 0
      then url := Copy( url, 1, Pos( '-', url ) - 1 );
  end;
  if Pos( 'www.allmusic.com', url ) > 0 then begin
    if Pos( 'mn0', url ) > 0
      then url := Copy( url, 1, Pos( 'artist', url ) + 6 ) + Copy( url, Pos( 'mn0', url ), 12 );
    if Pos( 'mw0', url ) > 0
      then url := Copy( url, 1, Pos( 'album', url ) + 5 ) + Copy( url, Pos( 'mw0', url ), 12 );
    if Pos( 'mr0', url ) > 0
      then url := Copy( url, 1, Pos( 'release', url ) + 7 ) + Copy( url, Pos( 'mr0', url ), 12 );
    if ( Pos( 'ma0', url ) > 0 ) and ( Pos( 'genre', url ) > 0 )
      then url := Copy( url, 1, Pos( 'genre', url ) + 5 ) + Copy( url, Pos( 'ma0', url ), 12 );
    if ( Pos( 'ma0', url ) > 0 ) and ( Pos( 'style', url ) > 0 )
      then url := Copy( url, 1, Pos( 'style', url ) + 5 ) + Copy( url, Pos( 'ma0', url ), 12 );
  end;
  if Pos( 'www.imdb.com', url ) > 0 then begin
    if Pos( 'title', url ) > 0
      then url := Copy( url, 1, Pos( 'title/tt', url ) + 15 );
    if Pos( 'name', url ) > 0
      then url := Copy( url, 1, Pos( 'name/nm', url ) + 14 );
  end;
  if Pos( 'www.kinopoisk.ru', url ) > 0 then begin
    if Pos( 'film', url ) > 0 then begin
      r := Copy( url, Pos( 'film/', url ) + 5, MaxInt );
      url := Copy( url, 1, Pos( 'film/', url ) + 4 );
      if Pos( '/', r ) > 0 then r := Copy( r, 1, Pos( '/', r ) - 1 );
      while Pos( '-', r ) > 0 do r := Copy( r, Pos( '-', r ) + 1, MaxInt );
      url := url + r;
    end;
  end;
  if Pos( 'www.youtube.com/embed', url ) > 0 then begin
    url := CutLeftStringSubStr( url, 'src="' );
    url := Copy( url, 1, Pos( '"', url ) - 1 );
    s := CutLeftStringSubStr( url, 'embed/' );
    s := LeftStr( s, 11 );
    url := 'https://www.youtube.com/embed/' + s;
  end;
  if Pos( 'www.youtube.com/watch', url ) > 0 then begin
    s := CutLeftStringSubStr( url, 'watch?v=' );
    s := LeftStr( s, 11 );
    url := 'https://www.youtube.com/watch?v=' + s;
  end;
  if Pos( 'youtu.be', url ) > 0 then begin
    s := CutLeftStringSubStr( url, 'youtu.be/' );
    s := LeftStr( s, 11 );
    url := 'https://www.youtube.com/watch?v=' + s;
  end;
  if Pos( 'records.su', url ) > 0 then begin
    url := CutStringChar( url, '#' );
  end;
  if Pos( 'last.fm', url ) > 0 then begin
    url := ReplaceStr ( url, '/de/', '/' );
    url := ReplaceStr ( url, '/es/', '/' );
    url := ReplaceStr ( url, '/fr/', '/' );
    url := ReplaceStr ( url, '/it/', '/' );
    url := ReplaceStr ( url, '/ja/', '/' );
    url := ReplaceStr ( url, '/pl/', '/' );
    url := ReplaceStr ( url, '/pt/', '/' );
    url := ReplaceStr ( url, '/ru/', '/' );
    url := ReplaceStr ( url, '/sv/', '/' );
    url := ReplaceStr ( url, '/tr/', '/' );
    url := ReplaceStr ( url, '/zh/', '/' );
  end;
  if ( RightStr( url, 1) = '/' ) then url := RightStringDelete( url, 1) ;
  if ( url = EmptyStr ) then Result := s else Result := url;
end;
//======================================================================================================================
function YouTubeWatch( URL: String ): String;
  var s: String;
begin
  s := CutLeftStringSubStr( url, 'embed/' );
  s := LeftStr( s, 11 );
  Result := 'https://www.youtube.com/watch?v=' + s;
end;
//======================================================================================================================
function YouTubeEmbed( URL: String ): String;
  var s: String;
begin
  s := CutLeftStringSubStr( url, 'watch?v=' );
  s := LeftStr( s, 11 );
  Result := 'https://www.youtube.com/embed/' + s;
end;
//======================================================================================================================
function SiteMap( Path, Ext, Skip, URL, Map: String ): Integer;
  var FileList: TStringList;
      i: Integer;
begin
  FileList := TStringList.Create;
  RecurseDir( Path, Ext, FileList, Skip );
  if ( FileList.Count > 0 ) then begin
    for i := 0 to FileList.Count - 1 do begin
      FileList[i] := StringReplace( FileList[i], Path, URL, [rfReplaceAll, rfIgnoreCase] );
      FileList[i] := StringReplace( FileList[i], '\', '/', [rfReplaceAll, rfIgnoreCase] );
    end;
    FileList.SaveToFile( Path + Map );
  end;
  Result := FileList.Count;
  FileList.Free;
end;
//======================================================================================================================
{$IFDEF VER150} // D7
function GetHTML( URL: String ): String;
  var h: TIdHTTP;
      s: TIdSSLIOHandlerSocket;
begin
  h := TIdHTTP.Create( nil );
  s := TIdSSLIOHandlerSocket.Create( nil );
  if Pos( 'https', URL ) > 0 then begin
    s.SSLOptions.Method := sslvSSLv23;
    h.IOHandler := s;
  end;
  try
    Result := h.Get( URL );
  except
    Result := EmptyStr;
  end;
  if Result = EmptyStr then Result := h.Get( URL );
  s.Free;
  h.Free;
end;
{$ENDIF}
//======================================================================================================================
end.
