{=======================================================================================================================

  Comming Library.

      .

========================================================================================================================

  :

  11.11.2012 [!]    Delphi XE2.
  12.11.2008 [*]       .
  30.08.2003 [+] WriteLog:  ,    .
  14.11.2002 [+]     .
  22.07.2002 [*]   .
  08.07.2002 [+]  .  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingLog.pas,v 1.2 2017/08/26 08:41:49 tsk Exp $
=======================================================================================================================}
unit CommingLog;

interface

  uses  Classes, Controls, Forms, SysUtils, CommingFile;

  procedure WriteLog( Message: String = '*' ); overload;
  procedure WriteLog( Message: String; const Args: array of const ); overload;

  //      :
  procedure WriteLogFormName;


  var LogName: String;

implementation
//======================================================================================================================
procedure WriteLog( Message: String );
  var Log: TextFile;
begin
  AssignFile( Log, LogName );
  if FileExists( LogName) then begin
    Append( Log )
  end else begin
    Rewrite( Log );
    Writeln( Log, '  ' + Application.Title + ' ' + DateToStr( Now ) );
  end;
  Writeln( Log, '');
  Writeln( Log, TimeToStr( Now ) + ' ]'+ StringOfChar( '-', 70 ));
  Writeln( Log, Message );
  CloseFile( Log );
end;
//======================================================================================================================
procedure WriteLog( Message: String; const Args: array of const );
begin
  WriteLog( Format( Message, Args ));
end;
//======================================================================================================================
procedure WriteLogFormName;
  var S: String;
      i: Integer;
begin
  S := '  :'#13#10;
  for i := 0 to Screen.FormCount - 1 do S := S + Screen.Forms[i].Name + ' (' + Screen.Forms[i].ClassName + ')'#13#10;
  WriteLog( S );
end;
//======================================================================================================================
initialization
  LogName := ChangeFileExt( Application.ExeName, FormatDateTime('YYMMDD', Now) + '.log' );
//======================================================================================================================
end.
