{=======================================================================================================================

  Comming Library.

     ProgressBar.

========================================================================================================================

  :

  18.10.2018 [*]  .
  11.09.2009 [*]  .
  18.02.2003 [+]   .
  29.11.2002 [*]    CommingDesign  CommingRuntime
  05.11.2002 [*]   .
  25.10.2002 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19982018 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingProgressBar.pas,v 1.3 2018/10/18 06:05:00 tsk Exp $
=======================================================================================================================}
unit CommingProgressBar;

interface

uses  SysUtils, Classes, Controls, StdCtrls, ComCtrls, Forms;

type
  TcoProgressBar = class(TProgressBar)
  private   { Private declarations }
    FLabel: TLabel;
    FCaption: TCaption;
    FLabelBlack: Boolean;
    procedure   SetCaption( const Value: TCaption );
    procedure   StepCaption;
    function    GetPosition: Integer;
    procedure   SetPosition( const Value: Integer );
    procedure SetLabelBlack(const Value: Boolean);
  protected { Protected declarations }
  public    { Public declarations }
    constructor Create( AOwner: TComponent ); override;
    procedure   StepOne;
    procedure   MaxInc( Delta: Integer; Text: String = '' );
  published { Published declarations }
    property    Caption: TCaption read FCaption write SetCaption;
    property    Position: Integer read GetPosition write SetPosition default 0;
    property    Step default 1;
    property    Smooth default True;
    property    LabelBlack: Boolean read FLabelBlack write SetLabelBlack default False;
  end;

implementation

//======================================================================================================================
{ TcoProgressBar }
//======================================================================================================================
constructor TcoProgressBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FLabel              := TLabel.Create( Self );
  FLabel.Parent       := Self;
  FLabel.Top          := ( Height - FLabel.Height - 2 ) div 2;
  FLabel.Left         := 4;
  FLabel.Layout       := tlCenter;
  FLabel.Transparent  := True;
  FLabel.Enabled      := False;
  FLabelBlack         := False;
  Step                := 1;
  Smooth              := True;
  Position            := 0;
  DoubleBuffered      := True;
end;
//======================================================================================================================
procedure TcoProgressBar.StepOne;
begin
  StepIt;
  StepCaption;
  Application.ProcessMessages;
end;
//======================================================================================================================
procedure TcoProgressBar.MaxInc( Delta: Integer; Text: String );
begin
  Max := Max + Delta;
  if Text <> '' then Caption := Text;
  Application.ProcessMessages;
end;
//======================================================================================================================
procedure TcoProgressBar.SetCaption( const Value: TCaption );
begin
  FCaption := Value;
  StepCaption;
  Application.ProcessMessages;
end;
//======================================================================================================================
procedure TcoProgressBar.StepCaption;
  var s: String;
begin
  s := Format( '%s (%.0f%%)', [ FCaption, ( 1 - ( Max - Position ) / Max ) * 100.0 ]);
  if FLabel.Caption <> s then FLabel.Caption := s;
end;
//======================================================================================================================
function TcoProgressBar.GetPosition: Integer;
begin
  Result := inherited Position;
end;
//======================================================================================================================
procedure TcoProgressBar.SetPosition( const Value: Integer );
begin
  inherited Position := Value;
  StepCaption;
end;
//======================================================================================================================
procedure TcoProgressBar.SetLabelBlack(const Value: Boolean);
begin
  if FLabelBlack <> Value then begin
    FLabelBlack     := Value;
    FLabel.Enabled  := Value;
  end;
end;
//======================================================================================================================
end.

